﻿using FarPoint.Excel;
using FarPoint.Win;
using FarPoint.Win.Chart;
using FarPoint.Win.Spread;
using FarPoint.Win.Spread.CellType;
using FarPoint.Win.Spread.Design;
using FarPoint.Win.Spread.DrawingSpace;
using FarPoint.Win.Spread.Model;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TestWin9
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

        }

        private void button2_Click(object sender, EventArgs e)
        {

            fpSpread1.ActiveSheet.ColumnHeader.Cells[0, 0].Renderer = new CustomRender();
            Debug.WriteLine(GetColumnHeaderPrefferedRowHeight(0).ToString());
        }

        private float GetColumnHeaderPrefferedRowHeight(int rowIndex)
        {
            int oldCount = fpSpread1.ActiveSheet.ColumnHeader.RowCount;
            int oldIndex = fpSpread1.ActiveSheet.ColumnHeaderAutoTextIndex;
            bool needAdjust = false;
            if (rowIndex == oldCount - 1)
            {
                needAdjust = true;
                fpSpread1.ActiveSheet.ColumnHeader.RowCount = oldCount + 1;
                fpSpread1.ActiveSheet.ColumnHeaderAutoTextIndex = oldCount;
            }
            float h = fpSpread1.ActiveSheet.ColumnHeader.Rows[rowIndex].GetPreferredHeight();

            if (needAdjust)
            {
                fpSpread1.ActiveSheet.ColumnHeader.RowCount = oldCount;
                fpSpread1.ActiveSheet.ColumnHeaderAutoTextIndex = oldIndex;
            }
            return h;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            fpSpread1.ActiveSheet.ColumnHeader.Cells[0, 1].Renderer = new WrapColumnHeaderRenderer();
            Debug.WriteLine(fpSpread1.ActiveSheet.ColumnHeader.Rows[0].GetPreferredHeight().ToString());
        }
    }

    public class CustomRender : FarPoint.Win.Spread.CellType.ColumnHeaderRenderer, IRenderer
    {

        Size IRenderer.GetPreferredSize(Graphics g, Size size, FarPoint.Win.Spread.Appearance appearance, object value, float zoomFactor)
        {
            return new Size(10, 10);
        }
    }

    /// <summary>
    /// This is a wrapper class
    /// </summary>
    public class WrapColumnHeaderRenderer : IRenderer, IHeaderImages, ISerializeSupport, IWordWrapSupport , IShrinkToFitSupport , IPdfSupport, IDisposable
    {
        private ColumnHeaderRenderer render;


        public WrapColumnHeaderRenderer()
        {
            render = new ColumnHeaderRenderer();
        }

        public Size GetPreferredSize(Graphics g, Size size, FarPoint.Win.Spread.Appearance appearance, object value, float zoomFactor)
        {
            return render.GetPreferredSize(g, size, appearance, value, zoomFactor);
        }

        public void PaintCell(Graphics g, Rectangle r, FarPoint.Win.Spread.Appearance appearance, object value, bool isSelected, bool isLocked, float zoomFactor)
        {
            render.PaintCell(g, r, appearance, value, isSelected, isLocked, zoomFactor);
        }

        public bool CanOverflow()
        {
            return render.CanOverflow();
        }

        public bool CanBeOverflown()
        {
            return render.CanBeOverflown();
        }

        public Image[] Images
        {
            get
            {
                return render.Images;
            }
            set
            {
                render.Images = value;
            }
        }

        public bool Serialize(System.Xml.XmlTextWriter w)
        {
            return render.Serialize(w);
        }

        public bool Deserialize(System.Xml.XmlNodeReader r)
        {
            return render.Deserialize(r);
        }

        public bool WordWrap
        {
            get
            {
                return render.WordWrap;
            }
            set
            {
                render.WordWrap = value;
            }
        }

        public bool ShrinkToFit
        {
            get
            {
                return render.ShrinkToFit;
            }
            set
            {
                render.ShrinkToFit = value;
            }
        }

        public void PaintCell(FarPoint.PDF.PdfGraphics g, RectangleF r, FarPoint.Win.Spread.Appearance appearance, object value, bool isSelected, bool isLocked, float zoomFactor)
        {
            render.PaintCell(g, r, appearance, value, isSelected, isLocked, zoomFactor);
        }

        public void Dispose()
        {
            render.Dispose();
        }
    }
}
